#-------------------------------------------------------------------------------
# Name:        PolygonsToSvg
# Purpose:
#
# Author:      jwezorek
#---------------------
#!/usr/bin/env python

def RgbToColorString(rgb):
    hexcolor = '#%02x%02x%02x' % rgb
    return hexcolor

def ScaleTuple(t, sc):
    return tuple(map( lambda x: x * sc, t))

def Write( filename, polygons, dictIndexToColor, width, height, scale  ):
    def WriteLoop(file, loop):
        for i in range(1,len(loop)):
            if (i == 1):
                file.writelines('M ')
            else:
                file.writelines('L ')
            file.writelines('%d %d ' % ScaleTuple(loop[i],scale))
        if (loop[0][0] != loop[-1][0] or loop[0][1] != loop[-1][1]):
            file.writelines('L %d %d ' % ScaleTuple(loop[0],scale))
        file.writelines('z ')

    def WritePolygon(file, polygon, scale):
        loops = polygon[0];
        color = polygon[1];
        file.writelines( '   <path d="' )

        for loop in loops:
            WriteLoop( file, loop )

        file.writelines( '" fill="%s" />\n' % RgbToColorString(dictIndexToColor[color]) )

    file = open(filename,"w")

    file.writelines( '<?xml version="1.0" standalone="no"?>\n' )
    file.writelines( '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n' )
    file.writelines( '<svg width="%dpx" height="%dpx" viewBox="0 0 %d %d" xmlns="http://www.w3.org/2000/svg" version="1.1">\n' % (width*scale,height*scale,width*scale, height*scale) )

    for poly in polygons:
        WritePolygon( file, poly, scale )

    file.writelines( '</svg>\n' )
    file.close()