import sys
from PIL import Image
import PolygonsToSvg
import ImageToIndexAry
import ExtractPolygons

def hex_to_rgb(value):
    try:
        value = value.lstrip('#')
        lv = len(value)
        return tuple(int(value[i:i+lv/3], 16) for i in range(0, lv, lv/3))
    except:
        print "Invalid hex color: %s" % value
        return []

def PolyToSvg(inp, out, scale, bkgd_color):
    img = Image.open(inp)
    (wd,hgt) = img.size
    (ary, dictIndexToColor, dictColorToIndex ) = ImageToIndexAry.Convert( img  )
    #bkgd_index = dictColorToIndex[(0,0,0)]
    polys = ExtractPolygons.Extract( ary, dictColorToIndex[bkgd_color] if bkgd_color != [] else [])
    PolygonsToSvg.Write( out, polys, dictIndexToColor, wd, hgt, scale)


if (len(sys.argv) < 3 or len(sys.argv) > 5):
    sys.exit('Usage: %s input_file output_file [scale] [bkgd color hex]' % sys.argv[0])
else:
    scale = int(sys.argv[3]) if (len(sys.argv) > 3) else 10
    bkgd = hex_to_rgb(sys.argv[4]) if (len(sys.argv) == 5) else []
    PolyToSvg( sys.argv[1], sys.argv[2], scale, bkgd )
